(function() {
  var CodeMirror, React, T, _, cx, div, textarea;

  _ = require('lodash');

  cx = require('classnames');

  CodeMirror = require('codemirror');

  React = require('react');

  T = React.PropTypes;

  div = React.createFactory('div');

  textarea = React.createFactory('textarea');

  module.exports = React.createClass({
    displayName: 'lite-code-editor',
    propTypes: {
      readOnly: T.bool,
      option: T.object,
      defaultValue: T.string,
      mode: T.string,
      name: T.string,
      theme: T.string,
      onChange: T.func.isRequired
    },
    getDefaultProps: function() {
      return {
        mode: 'null',
        readOnly: false,
        theme: 'default'
      };
    },
    componentDidMount: function() {
      var defaultOption, editor, option;
      defaultOption = {
        indentUnit: 2,
        indentWithTabs: true,
        lineNumbers: true,
        lineWrapping: false,
        placeholder: 'Code goes here...',
        smartIndent: true,
        tabSize: 2
      };
      editor = this.refs.editor.getDOMNode();
      option = _.assign({}, defaultOption, this.props.option, {
        mode: this.props.mode,
        readOnly: this.props.readOnly,
        theme: this.props.theme
      });
      this.editor = CodeMirror.fromTextArea(editor, option);
      return this.editor.on('change', this.onEditorChange);
    },
    componentWillReceiveProps: function(nextProps) {
      if (this.editor.getOption('mode') !== nextProps.mode) {
        return this.editor.setOption('mode', nextProps.mode);
      }
    },
    onEditorChange: function() {
      var value;
      value = this.editor.getValue();
      return this.props.onChange(value);
    },
    renderEditor: function() {
      return textarea({
        className: 'editor',
        ref: 'editor',
        readOnly: this.props.readOnly,
        defaultValue: this.props.defaultValue,
        placeholder: this.props.placeholder,
        onChange: this.props.onChange
      });
    },
    render: function() {
      var className, obj;
      className = cx('lite-code-editor', (
        obj = {},
        obj["is-for-" + this.props.name] = this.props.name != null,
        obj
      ));
      return div({
        className: className
      }, this.renderEditor());
    }
  });

}).call(this);
